package com.sambath.kunkhmer.remote

import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class LivesResponse(
    @Json(name = "code")
    val resultCode: Int,
    @Json(name = "message")
    val message: ResponseMessage,
    @Json(name = "data")
    val data: LivesData?
)

@JsonClass(generateAdapter = true)
data class LivesData(
    @Json(name = "object")
    val obj: MutableList<LivesInfo>,
)

@JsonClass(generateAdapter = true)
data class LivesInfo(
    @Json(name = "_id")
    val liveInfoId: LivesInfoId,
    @Json(name = "fighters")
    val fighters: MutableList<LiveInfoFighters>,
)

@JsonClass(generateAdapter = true)
data class LivesInfoId(
    @Json(name = "_id")
    val id: String,
    @Json(name = "status")
    val status: Boolean,
    @Json(name = "fighter_id")
    val fighterId: String,
    @Json(name = "createdAt")
    val createdAt: String,
)

@JsonClass(generateAdapter = true)
data class LiveInfoFighters(
    @Json(name = "_id")
    val id: String,
    @Json(name = "name")
    val name: String,
    @Json(name = "desc")
    val desc: String,
    @Json(name = "weight")
    val weight: String,
    @Json(name = "high")
    val height: String,
    @Json(name = "nationality")
    val nationality: String,
    @Json(name = "filename")
    val filename: String,
)