package com.sambath.kunkhmer.remote

import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class NewsResponse(
    @Json(name = "code")
    val resultCode: Int,
    @Json(name = "message")
    val message: ResponseMessage,
    @Json(name = "data")
    val data: NewsData?
)

@JsonClass(generateAdapter = true)
data class NewsData(
    @Json(name = "object")
    val obj: MutableList<News>,
)

@JsonClass(generateAdapter = true)
data class News(
    @Json(name = "_id")
    val id: String,
    @Json(name = "viewer")
    val viewer: Int,
    @Json(name = "title")
    val title: String,
    @Json(name = "desc")
    val desc: String,
    @Json(name = "createdAt")
    val createdAt: String,
    @Json(name = "filename")
    val filename: String?,
)
