package com.sambath.kunkhmer.remote

import com.gdtlib.lib.adapter.BaseListItem
import com.squareup.moshi.Json
import com.squareup.moshi.JsonClass

@JsonClass(generateAdapter = true)
data class ReportResponse(

    @Json(name = "code")
    val resultCode: String,
    @Json(name = "message")
    val message: ReportMessage,
    @Json(name = "data")
    val data: ReportData?
)

@JsonClass(generateAdapter = true)
data class ReportMessage(
    @Json(name = "code")
    val code: String,

    @Json(name = "descriptions")
    val description: String)

@JsonClass(generateAdapter = true)
data class ReportData(

    @Json(name = "objLotoBettingWin")
    val winList: List<Win>?,

    @Json(name = "objLotoBettingWinLose")
    val winLostLst: List<WinLost>?,

    @Json(name = "objGroupStatement")
    val statementList: List<Statement>?

)

@JsonClass(generateAdapter = true)
data class Win(
    @Json(name = "_id")
    var id: String,

    @Json(name = "date")
    val date: String,

    @Json(name = "filter_date")
    var filterDate: String,

    @Json(name = "no")
    val no: String,

    @Json(name = "user_name")
    val userName: String,

    @Json(name = "bank_account")
    val bankAccount: String,

    @Json(name = "total_ramdom")
    val totalRandom: String,

    @Json(name = "type_of_betting")
    val typeOfBetting: String,

    @Json(name = "color")
    val color: String,

    @Json(name = "amount")
    val amount: String,

    @Json(name = "cast")
    val cast: String,

    @Json(name = "win_lose")
    val win_lose: String?,

    @Json(name = "amount_win")
    val amount_win: String?
): BaseListItem(){
    override fun getUnique(): String = id

}
@JsonClass(generateAdapter = true)
data class WinLost(
    @Json(name = "_id")
    var id: String,

    @Json(name = "date")
    val date: String,

    @Json(name = "filter_date")
    var filterDate: String,

    @Json(name = "no")
    val no: String,

    @Json(name = "user_name")
    val userName: String,

    @Json(name = "bank_account")
    val bankAccount: String,

    @Json(name = "total_ramdom")
    val totalRandom: String,

    @Json(name = "type_of_betting")
    val typeOfBetting: String,

    @Json(name = "color")
    val color: String,

    @Json(name = "amount")
    val amount: String,

    @Json(name = "cast")
    val cast: String,

    @Json(name = "win_lose")
    val win_lose: String?,

    @Json(name = "amount_win")
    val amount_win: String?
): BaseListItem(){
    override fun getUnique(): String = id

}

@JsonClass(generateAdapter = true)
data class Statement(
    @Json(name = "_id")
    var id: String,

    @Json(name = "date")
    val date: String,

    @Json(name = "note")
    val note: String,

    @Json(name = "note_khmer")
    val khmerNote: String?,

    @Json(name = "amount")
    val amount: Double?,

    @Json(name = "amount_win")
    val amount_win: Double?

    ): BaseListItem(){
    override fun getUnique(): String = id

}

